#!/usr/bin/env jython
# Demonstration of non-blocking socket truncating a file.

import socket

# Get some data
f = open("cat.jpg", "rb")
file_data = f.read()
f.close()

port = 8888 
s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
s.bind(('', port))
s.listen(1)
print "Server listening on port %s" % port
while 1:
    client, addr = s.accept()
    print 'Connected by', addr
    client.setblocking(0)
    bytes_to_send = file_data
    while bytes_to_send:
        sent = client.send(file_data)
        print "%s bytes sent to client." % sent
        bytes_to_send = bytes_to_send[sent:]
    print "All %s bytes sent to client." % len(file_data)
    client.close()
    print "Disconnected"
